## ?q=aHR0cHM6Ly9naXRodWIuY29tL2RhbmlsZXZza3kvdGVybWluYWwvYXJjaGl2ZS9yZWZzL3RhZ3MvMC45MC4zLnppcA

=== CMakeLists.txt ===
#
#
# ***********************************************************************************
# * Copyright (C) 2011 - 2020, BlockSettle AB
# * Distributed under the GNU Affero General Public License (AGPL v3)
# * See LICENSE or http://www.gnu.org/licenses/agpl.html
# *
# **********************************************************************************
#
#
CMAKE_MINIMUM_REQUIRED( VERSION 3.3 )

SET(CMAKE_CXX_STANDARD 14)
SET(CMAKE_CXX_STANDARD_REQUIRED ON)
SET(CMAKE_CXX_EXTENSIONS OFF)
SET(QT_USE_QTDBUS ON)

SET(PROJECT_NAME_STR BS_Terminal)
PROJECT(${PROJECT_NAME_STR})

IF (NOT CMAKE_BUILD_TYPE)
   SET(CMAKE_BUILD_TYPE "Debug")
endif()

option(BSTERMINAL_SHARED_LIBS "Build shared libraries" OFF)

add_definitions(-DSTATIC_BUILD)
add_definitions(-DSPDLOG_ACTIVE_LEVEL=SPDLOG_LEVEL_DEBUG)

IF(CMAKE_BUILD_TYPE STREQUAL "Debug")
   IF(BSTERMINAL_SHARED_LIBS)
      SET(THIRD_PARTY_BUILD_MODE "debug-shared")
   ELSE()
      SET(THIRD_PARTY_BUILD_MODE "debug")
   ENDIF()
ELSE()
   IF(BSTERMINAL_SHARED_LIBS)
      SET(THIRD_PARTY_BUILD_MODE "release-shared")
   ELSE()
      SET(THIRD_PARTY_BUILD_MODE "release")
   ENDIF()
ENDIF()

add_definitions(-DNOMINMAX)

# Force Armory to ignore Crypto++ and use libbtc instead.
add_definitions(-DLIBBTC_ONLY)

IF (APPLE)
   add_definitions(-DMDB_USE_POSIX_SEM=1)
ENDIF(APPLE)

IF (PRODUCTION_BUILD)
   add_definitions(-DPRODUCTION_BUILD)
ENDIF (PRODUCTION_BUILD)

# Force 64-bit builds and min target for macOS. If the min target changes,
# update generate.py too.
if(APPLE)
	set(CMAKE_OSX_DEPLOYMENT_TARGET 10.12 CACHE STRING "" FORCE)
	set(CMAKE_OSX_ARCHITECTURES "x86_64" CACHE STRING "macOS architecture to build; 64-bit is expected" FORCE)
endif(APPLE)

# Enforce Windows 7 minimum target and MSVS 2017 compiler minimum.
IF(WIN32)
	SET(_WIN32_WINNT 0x0601 CACHE INTERNAL "Setting _WIN32_WINNT to 0x0601 for Windows 7 minimum APIs.")
	SET(WINVER 0x0601 CACHE INTERNAL "Setting WINVER to 0x0601 for Windows 7 minimum APIs.")

	IF(MSVC_VERSION LESS 1910)
		MESSAGE(FATAL_ERROR "MSVC 141 or higher is required to build the BlockSettle Terminal.")
	ENDIF()
ENDIF()

# setup directories
SET(BLOCK_SETTLE_ROOT ${CMAKE_SOURCE_DIR})
SET(TERMINAL_GUI_ROOT ${CMAKE_SOURCE_DIR})

set(CMAKE_MODULE_PATH "${TERMINAL_GUI_ROOT}/common/build_scripts/CMakeModules")

set(QML_IMPORT_PATH "${BLOCK_SETTLE_ROOT}/BlockSettleSigner/qml" CACHE STRING "QML import path")
set(QML2_IMPORT_PATH "${BLOCK_SETTLE_ROOT}/BlockSettleSigner/qml" CACHE STRING "QML2 import path")

# set versions info
# Terminal, PB, PuB and offline tools share same version for consistency
SET(BS_VERSION_MAJOR 0 )
SET(BS_VERSION_MINOR 90 )
SET(BS_VERSION_PATCH 3 )
SET(BS_VERSION_STRING "${BS_VERSION_MAJOR}.${BS_VERSION_MINOR}.${BS_VERSION_PATCH}")

include(GetGitRevisionDescription)
get_git_head_revision(GIT_REFSPEC GIT_SHA1)

IF( GIT_SHA1 STREQUAL GITDIR-NOTFOUND )
    IF (NOT DEFINED ENV{BS_GIT_REVISION})
	MESSAGE( FATAL_ERROR "Building from a none git repository, please define the shell veriable revision BS_GIT_REVISION=XXX")
    ELSE()
	SET(GIT_SHA1 "$ENV{BS_GIT_REVISION}")
    ENDIF()
ENDIF ()

# we only take the 8 first characters
string(SUBSTRING ${GIT_SHA1} 0 8 BS_REVISIOIN_SHA1)

# set DEV_3RD_ROOT env variable to your custom location of 3rd party components
IF (DEFINED ENV{DEV_3RD_ROOT})
   GET_FILENAME_COMPONENT(FULL_3RD_PATH $ENV{DEV_3RD_ROOT} ABSOLUTE)
   SET(THIRD_PARTY_COMMON_DIR ${FULL_3RD_PATH}/${THIRD_PARTY_BUILD_MODE})
ELSE()
   GET_FILENAME_COMPONENT(TOP_DIRECTORY ${BLOCK_SETTLE_ROOT} DIRECTORY)
   SET(THIRD_PARTY_COMMON_DIR ${TOP_DIRECTORY}/3rd/${THIRD_PARTY_BUILD_MODE})
ENDIF()

SET( PROJECT_BINARY_DIR ${BLOCK_SETTLE_ROOT}/build_terminal/${CMAKE_BUILD_TYPE} )
SET( EXECUTABLE_OUTPUT_PATH ${PROJECT_BINARY_DIR}/bin )

include(GCCToolchain)
IF(NOT MSVC)
   include(LLVMToolchain)
ENDIF(MSVC)
include(LTO)
include(CompilerWarnings)
include(CompilerColorDiagnostics)

IF( WIN32 )
   # output libs to same path as binaries on windows just to make life easier
   IF(BSTERMINAL_SHARED_LIBS)
      SET(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /MD")
      SET(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} /MDd")
   ELSE()
      SET(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /MT /Zl /O2 /Ob2 /DNDEBUG")
      SET(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} /D_DEBUG -DBUILD_MT_RELEASE=OFF /MTd /Zi /Zl /Ob0 /Od /RTC1")
   ENDIF()
   # Speedup compilation
   add_compile_options($<$<CXX_COMPILER_ID:MSVC>:/MP>)
   SET( LIBRARY_OUTPUT_PATH ${EXECUTABLE_OUTPUT_PATH} )
ELSE()
   SET( LIBRARY_OUTPUT_PATH ${PROJECT_BINARY_DIR}/libs )
   SET(CMAKE_CXX_FLAGS  "${CMAKE_CXX_FLAGS} -Wno-unused-parameter")
ENDIF()

SET(CMAKE_INCLUDE_CURRENT_DIR ON)

#find qt
# Instruct CMake to run moc automatically when needed.
SET(CMAKE_AUTOMOC ON)

# set required dirs
SET(QT5_ROOT ${THIRD_PARTY_COMMON_DIR}/Qt5)
SET(QT5_BIN_ROOT ${QT5_ROOT}/bin)
SET(QT5_LIB_ROOT ${QT5_ROOT}/lib)
SET(QT5_QML_ROOT ${QT5_ROOT}/qml)
SET(QT5_PLUGINS_ROOT ${QT5_ROOT}/plugins)

SET(CMAKE_PREFIX_PATH ${CMAKE_PREFIX_PATH} ${QT5_ROOT})
SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${QT5_LIB_ROOT}/cmake)

FIND_PACKAGE(Qt5Core REQUIRED)
FIND_PACKAGE(Qt5Gui REQUIRED)
FIND_PACKAGE(Qt5Widgets REQUIRED)
FIND_PACKAGE(Qt5Network REQUIRED)
FIND_PACKAGE(Qt5PrintSupport REQUIRED)
FIND_PACKAGE(Qt5Qml REQUIRED)
FIND_PACKAGE(Qt5Quick REQUIRED)
FIND_PACKAGE(Qt5QuickControls2 REQUIRED)
FIND_PACKAGE(Qt5Charts REQUIRED)
FIND_PACKAGE(Qt5Sql REQUIRED)
FIND_PACKAGE(Qt5Svg REQUIRED)

INCLUDE_DIRECTORIES(${Qt5Core_INCLUDE_DIRS})
INCLUDE_DIRECTORIES(${Qt5Gui_INCLUDE_DIRS})
INCLUDE_DIRECTORIES(${Qt5Widgets_INCLUDE_DIRS})
INCLUDE_DIRECTORIES(${Qt5Network_INCLUDE_DIRS})
INCLUDE_DIRECTORIES(${Qt5PrintSupport_INCLUDE_DIRS})
INCLUDE_DIRECTORIES(${Qt5Qml_INCLUDE_DIRS})
INCLUDE_DIRECTORIES(${Qt5Quick_INCLUDE_DIRS})
INCLUDE_DIRECTORIES(${Qt5QuickControls2_INCLUDE_DIRS})
INCLUDE_DIRECTORIES(${Qt5Charts_INCLUDE_DIRS})
INCLUDE_DIRECTORIES(${Qt5Sql_INCLUDE_DIRS})
INCLUDE_DIRECTORIES(${Qt5Svg_INCLUDE_DIRS})

IF ( UNIX AND NOT APPLE )
   FIND_PACKAGE(Qt5DBus REQUIRED)
   ADD_DEFINITIONS( "-DBS_USE_DBUS" )
   INCLUDE_DIRECTORIES(${Qt5DBus_INCLUDE_DIRS})
ELSE ()
   FILE(WRITE ${CMAKE_CURRENT_BINARY_DIR}/dbus_dummy.c "")
   ADD_LIBRARY(dbus_dummy ${CMAKE_CURRENT_BINARY_DIR}/dbus_dummy.c)
   ADD_LIBRARY(Qt5::DBus STATIC IMPORTED)
   IF (MSVC_IDE)
      SET_PROPERTY(TARGET Qt5::DBus PROPERTY
         IMPORTED_LOCATION ${LIBRARY_OUTPUT_PATH}/${CMAKE_BUILD_TYPE}/${CMAKE_STATIC_LIBRARY_PREFIX}dbus_dummy${CMAKE_STATIC_LIBRARY_SUFFIX})
   ELSE ()
      SET_PROPERTY(TARGET Qt5::DBus PROPERTY
         IMPORTED_LOCATION ${LIBRARY_OUTPUT_PATH}/${CMAKE_STATIC_LIBRARY_PREFIX}dbus_dummy${CMAKE_STATIC_LIBRARY_SUFFIX})
   ENDIF ()
ENDIF ()

ADD_DEFINITIONS( -DQT_NO_CAST_TO_ASCII -DQT_NO_CAST_FROM_ASCII )
IF(NOT WIN32)
   ADD_DEFINITIONS(-Wno-multichar -Wextra -Wall -Wformat=2)
ENDIF(NOT WIN32)

#setup zeromq
SET(ZEROMQ_ROOT         ${THIRD_PARTY_COMMON_DIR}/ZeroMQ)
SET(ZEROMQ_INCLUDE_DIR  ${ZEROMQ_ROOT}/include)
SET(ZEROMQ_LIB_DIR      ${ZEROMQ_ROOT}/lib)

INCLUDE_DIRECTORIES( ${ZEROMQ_INCLUDE_DIR} )

SET(CMAKE_LIBRARY_PATH ${CMAKE_LIBRARY_PATH} ${ZEROMQ_ROOT}/lib)
IF( WIN32 )
   IF(CMAKE_BUILD_TYPE STREQUAL "Debug")
      SET( ZMQ_LIB_NAME "libzmq-v140-mt-gd-4_3_2" )
   ELSE()
      SET( ZMQ_LIB_NAME "libzmq-v140-mt-4_3_2" )
   ENDIF(CMAKE_BUILD_TYPE STREQUAL "Debug")
ELSE ()
   IF(BSTERMINAL_SHARED_LIBS)
      SET( ZMQ_LIB_NAME "libzmq.so" "zmq" )
   ELSE()
      SET( ZMQ_LIB_NAME "libzmq.a" "zmq" )
   ENDIF()
ENDIF( WIN32 )
FIND_LIBRARY(ZMQ_LIB NAMES ${ZMQ_LIB_NAME} REQUIRED NO_CMAKE_ENVIRONMENT_PATH NO_SYSTEM_ENVIRONMENT_PATH NO_CMAKE_SYSTEM_PATH)

IF( NOT ZMQ_LIB )
   IF( WIN32 )
      IF(CMAKE_BUILD_TYPE STREQUAL "Debug")
         SET( ZMQ_LIB_NAME "libzmq-v141-mt-gd-4_3_2" )
      ELSE()
         SET( ZMQ_LIB_NAME "libzmq-v141-mt-4_3_2" )
      ENDIF(CMAKE_BUILD_TYPE STREQUAL "Debug")
   ENDIF( WIN32 )
   FIND_LIBRARY(ZMQ_LIB NAMES ${ZMQ_LIB_NAME} REQUIRED NO_CMAKE_ENVIRONMENT_PATH NO_SYSTEM_ENVIRONMENT_PATH NO_CMAKE_SYSTEM_PATH)
   IF( NOT ZMQ_LIB)
      MESSAGE(FATAL_ERROR "Could not find ZMQ lib")
   ENDIF( NOT ZMQ_LIB)
ENDIF( NOT ZMQ_LIB)

# OpenSSL libs
SET(OPENSSL_ROOT_DIR        ${THIRD_PARTY_COMMON_DIR}/OpenSSL)
SET(CMAKE_LIBRARY_PATH      ${CMAKE_LIBRARY_PATH} ${OPENSSL_ROOT_DIR}/lib)
set(OPENSSL_USE_STATIC_LIBS TRUE)

find_package(OpenSSL REQUIRED)

include(InstallRequiredSystemLibraries)
INSTALL(FILES ${CMAKE_INSTALL_SYSTEM_RUNTIME_LIBS} DESTINATION bin COMPONENT Libraries)

SET(OPENSSL_LIBS
    OpenSSL::SSL
    OpenSSL::Crypto
)
INCLUDE_DIRECTORIES( ${OPENSSL_INCLUDE_DIR} )

# setup botan
SET(BOTAN_PACKAGE_ROOT ${THIRD_PARTY_COMMON_DIR}/botan)
SET(BOTAN_LIB_DIR ${BOTAN_PACKAGE_ROOT}/lib)
SET(BOTAN_INCLUDE_DIR ${BOTAN_PACKAGE_ROOT}/include/botan-2)

IF (WIN32)
   SET(BOTAN_LIB_NAME botan-2.lib botan.lib)
ELSE(WIN32)
   IF(BSTERMINAL_SHARED_LIBS)
      SET(BOTAN_LIB_NAME libbotan-2.so)
   ELSE()
      SET(BOTAN_LIB_NAME libbotan-2.a)
   ENDIF()
ENDIF(WIN32)

FIND_LIBRARY( BOTAN_LIB NAMES ${BOTAN_LIB_NAME} PATHS ${BOTAN_LIB_DIR} NO_DEFAULT_PATH )
IF( NOT BOTAN_LIB)
   MESSAGE( FATAL_ERROR "Could not find botan lib in ${BOTAN_LIB_DIR}")
ENDIF()

##setup libusb
if (UNIX)
    SET(LIBUSB_PACKAGE_ROOT ${THIRD_PARTY_COMMON_DIR}/libusb)
    SET(LIBUSB_LIB_DIR ${LIBUSB_PACKAGE_ROOT}/lib)
    SET(LIBUSB_INCLUDE_DIR ${LIBUSB_PACKAGE_ROOT}/include)

    SET(LIBUSB_LIB_NAME libusb-1.0.a)
    FIND_LIBRARY( LIBUSB_LIB NAMES ${LIBUSB_LIB_NAME} PATHS ${LIBUSB_LIB_DIR} NO_DEFAULT_PATH )
    IF( NOT LIBUSB_LIB)
       MESSAGE( FATAL_ERROR "Could not find libusb lib in ${LIBUSB_LIB_DIR}")
    ENDIF()
endif (UNIX)


# setup libwebsockets
SET(WS_PACKAGE_ROOT ${THIRD_PARTY_COMMON_DIR}/libwebsockets)
SET(WS_LIB_DIR ${WS_PACKAGE_ROOT}/lib)
SET(WS_INCLUDE_DIR ${WS_PACKAGE_ROOT}/include)

IF (WIN32)
   IF(BSTERMINAL_SHARED_LIBS)
      SET(WS_LIB_NAME websockets)
   ELSE()
      SET(WS_LIB_NAME websockets_static)
   ENDIF()
ELSE(WIN32)
   IF(BSTERMINAL_SHARED_LIBS)
      SET(WS_LIB_NAME libwebsockets.so)
   ELSE(BSTERMINAL_SHARED_LIBS)
      SET(WS_LIB_NAME libwebsockets.a)
   ENDIF()
ENDIF(WIN32)

FIND_LIBRARY(WS_LIB NAMES ${WS_LIB_NAME} PATHS ${WS_LIB_DIR} NO_DEFAULT_PATH )
IF(NOT WS_LIB)
   MESSAGE(FATAL_ERROR "Could not find libwebsockets in ${WS_LIB_DIR}")
ENDIF()
INCLUDE_DIRECTORIES(${WS_INCLUDE_DIR})

#add lib qrencode
SET(QRENCODE_ROOT             ${THIRD_PARTY_COMMON_DIR}/LibQREncode)
SET(QRENCODE_LIB_DIR          ${QRENCODE_ROOT}/lib)
SET(QRENCODE_INCLUDE_DIR      ${QRENCODE_ROOT}/include)

SET(QRENCODE_LIB_NAME "qrencode")
IF (WIN32)
   IF (CMAKE_BUILD_TYPE STREQUAL "Debug")
      SET(QRENCODE_LIB_NAME "qrencoded")
   ENDIF ()
ENDIF (WIN32)
FIND_LIBRARY(QRENCODE_LIB NAMES ${QRENCODE_LIB_NAME} REQUIRED PATHS ${QRENCODE_LIB_DIR} NO_DEFAULT_PATH)
IF(NOT QRENCODE_LIB)
   MESSAGE(FATAL_ERROR "Could not find QrEncode lib")
ENDIF(NOT QRENCODE_LIB)

INCLUDE_DIRECTORIES( ${QRENCODE_INCLUDE_DIR} )

# add SPDLOG
SET(SPDLOG_INCLUDE_DIR ${THIRD_PARTY_COMMON_DIR}/SPDLog/include)
INCLUDE_DIRECTORIES( ${SPDLOG_INCLUDE_DIR} )

# setup libbtc
SET(LIBBTC_PACKAGE_ROOT ${THIRD_PARTY_COMMON_DIR}/libbtc)
SET(LIBBTC_LIB_DIR ${LIBBTC_PACKAGE_ROOT}/lib)
SET(LIBBTC_INCLUDE_DIR ${LIBBTC_PACKAGE_ROOT}/include)

IF (WIN32)
   SET(LIBBTC_LIB_NAME libbtc)
ELSE(WIN32)
   SET(LIBBTC_LIB_NAME liblibbtc.a)
ENDIF(WIN32)

FIND_LIBRARY( LIBBTC_LIB NAMES ${LIBBTC_LIB_NAME} PATHS ${LIBBTC_LIB_DIR} NO_DEFAULT_PATH )
IF( NOT LIBBTC_LIB)
   MESSAGE( FATAL_ERROR "Could not find libbtc in ${LIBBTC_LIB_DIR}")
ENDIF()
INCLUDE_DIRECTORIES( ${LIBBTC_INCLUDE_DIR} )

# setup libchacha20poly1305
SET(LIBCP_PACKAGE_ROOT ${THIRD_PARTY_COMMON_DIR}/libchacha20poly1305)
SET(LIBCP_LIB_DIR ${LIBCP_PACKAGE_ROOT}/lib)
SET(LIBCP_INCLUDE_DIR ${LIBCP_PACKAGE_ROOT}/include)

SET(LIBCP_LIB_NAME libchacha20poly1305)

FIND_LIBRARY(LIBCP_LIB NAMES ${LIBCP_LIB_NAME} PATHS ${LIBCP_LIB_DIR} NO_DEFAULT_PATH )
IF( NOT LIBCP_LIB)

=== BlockSettleApp/CMakeLists.txt ===
#
#
# ***********************************************************************************
# * Copyright (C) 2018 - 2020, BlockSettle AB
# * Distributed under the GNU Affero General Public License (AGPL v3)
# * See LICENSE or http://www.gnu.org/licenses/agpl.html
# *
# **********************************************************************************
#
#
PROJECT( ${BLOCKSETTLE_APP_NAME} )

FILE(GLOB SOURCES *.cpp)
FILE(GLOB HEADERS *.h)

INCLUDE_DIRECTORIES( ${COMMON_UI_LIB_INCLUDE_DIR} )
INCLUDE_DIRECTORIES( ${COMMON_LIB_INCLUDE_DIR} )
INCLUDE_DIRECTORIES( ${BLOCKSETTLE_UI_INCLUDE_DIR} )
INCLUDE_DIRECTORIES( ${BS_NETWORK_INCLUDE_DIR} )
INCLUDE_DIRECTORIES( ${BS_COMMON_ENUMS_INCLUDE_DIR} )
INCLUDE_DIRECTORIES( ${BS_COMMUNICATION_INCLUDE_DIR} )
INCLUDE_DIRECTORIES( ${WALLET_LIB_INCLUDE_DIR} )
INCLUDE_DIRECTORIES( ${CRYPTO_LIB_INCLUDE_DIR} )
INCLUDE_DIRECTORIES( ${BOTAN_INCLUDE_DIR} )
INCLUDE_DIRECTORIES( ${Qt5Svg_INCLUDE_DIRS} )

IF ( APPLE )
    SET( BUNDLE_NAME "BlockSettle Terminal" )

    SET( MACOSX_BUNDLE_BUNDLE_NAME ${BUNDLE_NAME} )
    SET( MACOSX_BUNDLE_GUI_IDENTIFIER "com.blocksettle.terminal" )
    SET( MACOSX_BUNDLE_BUNDLE_VERSION ${BS_VERSION_STRING})
    SET( MACOSX_BUNDLE_SHORT_VERSION_STRING ${BS_VERSION_STRING})
    SET( MACOSX_BUNDLE_LONG_VERSION_STRING ${BS_VERSION_STRING})

    SET( MACOSX_BUNDLE_ICON_FILE "Blocksettle.icns" )

    SET(BS_TERMINAL_ICNS_FILE "${BLOCKSETTLE_UI_INCLUDE_DIR}/resources/Blocksettle.icns")

    SET_SOURCE_FILES_PROPERTIES( ${BS_TERMINAL_ICNS_FILE} PROPERTIES MACOSX_PACKAGE_LOCATION Resources)
    ADD_EXECUTABLE( ${BLOCKSETTLE_APP_NAME} MACOSX_BUNDLE ${SOURCES} ${HEADERS} ${BS_TERMINAL_ICNS_FILE})
    SET_TARGET_PROPERTIES( ${BLOCKSETTLE_APP_NAME} PROPERTIES OUTPUT_NAME "${BUNDLE_NAME}" )
ELSEIF ( WIN32 )
    ADD_EXECUTABLE( ${BLOCKSETTLE_APP_NAME} WIN32 ${SOURCES} ${HEADERS} blocksettle.rc )
ELSE ()
    ADD_EXECUTABLE( ${BLOCKSETTLE_APP_NAME} ${SOURCES} ${HEADERS} )
ENDIF ()

TARGET_LINK_LIBRARIES( ${BLOCKSETTLE_APP_NAME}
   ${BLOCKSETTLE_UI_LIBRARY_NAME}
   ${BS_NETWORK_LIB_NAME}
   ${CPP_WALLET_LIB_NAME}
   ${CRYPTO_LIB_NAME}
   ${BOTAN_LIB}
   ${ZMQ_LIB}
   ${QRENCODE_LIB}
   ${QT_LINUX_LIBS}
   ${WS_LIB}
   Qt5::Qml
   Qt5::Core
   Qt5::Widgets
   Qt5::Gui
   Qt5::Network
   Qt5::PrintSupport
   Qt5::Core
   Qt5::Svg
   Qt5::DBus
   ${QT_LIBS}
   ${OS_SPECIFIC_LIBS}
   ${OPENSSL_LIBS}
   )

=== BlockSettleHW/CMakeLists.txt ===
#
#
# ***********************************************************************************
# * Copyright (C) 2020 - 2020, BlockSettle AB
# * Distributed under the GNU Affero General Public License (AGPL v3)
# * See LICENSE or http://www.gnu.org/licenses/agpl.html
# *
# **********************************************************************************
#
#
PROJECT( ${BLOCKSETTLE_HW_LIBRARY_NAME} )

SET(BLOCKSETTLE_HW_ROOT ${CMAKE_CURRENT_SOURCE_DIR})

file(COPY ${THIRD_PARTY_COMMON_DIR}/hidapi/hidapi.h
    DESTINATION ${BLOCKSETTLE_HW_ROOT}/ledger/hidapi)
file(COPY ${THIRD_PARTY_COMMON_DIR}/hidapi/hid.c
    DESTINATION ${BLOCKSETTLE_HW_ROOT}/ledger/hidapi)

FILE(GLOB SOURCES
   *.cpp
   trezor/*.cpp
   ledger/*.cpp
   ledger/hidapi/*.c
)

FILE(GLOB HEADERS
   *.h
   trezor/*.h
   ledger/*.h
   ledger/hidapi/*.h
)

INCLUDE_DIRECTORIES( ${WALLET_LIB_INCLUDE_DIR} )
INCLUDE_DIRECTORIES( ${BS_NETWORK_INCLUDE_DIR} )
INCLUDE_DIRECTORIES( ${COMMON_LIB_INCLUDE_DIR} )

if (UNIX)
    INCLUDE_DIRECTORIES( ${LIBUSB_INCLUDE_DIR} )
endif (UNIX)

SET(GENERATED_SOURCE_FILES "")
SET(GENERATED_HEADER_FILES "")
SET(GENERATED_INCLUDE_DIRS "")

FUNCTION(GENERATE_PROTO IN_DIR OUT_DIR)
   FILE(MAKE_DIRECTORY ${OUT_DIR})

   FILE(GLOB PROTO_FILES ${IN_DIR}/*.proto)

   FOREACH(PROTO_FILE ${PROTO_FILES})
      GET_FILENAME_COMPONENT(PROTO_NAME "${PROTO_FILE}" NAME_WE)

      SET(PROTO_SOURCE_FILE "${OUT_DIR}/${PROTO_NAME}.pb.cc")
      SET(PROTO_HEADER_FILE "${OUT_DIR}/${PROTO_NAME}.pb.h")

      SET(PROTO_SOURCE_FILES ${PROTO_SOURCE_FILES} ${PROTO_SOURCE_FILE})
      SET(PROTO_HEADER_FILES ${PROTO_HEADER_FILES} ${PROTO_HEADER_FILE})

      ADD_CUSTOM_COMMAND(OUTPUT ${PROTO_SOURCE_FILE}
                         OUTPUT ${PROTO_HEADER_FILE}
                         DEPENDS ${PROTO_FILE}
                         COMMAND ${PROTOBUF_PROTOC_EXECUTABLE} ${PROTO_FILE} --cpp_out=${OUT_DIR} --proto_path=${IN_DIR}
                         WORKING_DIRECTORY ${BLOCKSETTLE_HW_ROOT}
      )
   ENDFOREACH(PROTO_FILE)

   SET(GENERATED_SOURCE_FILES ${GENERATED_SOURCE_FILES} ${PROTO_SOURCE_FILES} PARENT_SCOPE)
   SET(GENERATED_HEADER_FILES ${GENERATED_HEADER_FILES} ${PROTO_HEADER_FILES} PARENT_SCOPE)

   SET(GENERATED_INCLUDE_DIRS ${GENERATED_INCLUDE_DIRS} ${OUT_DIR} PARENT_SCOPE)

ENDFUNCTION(GENERATE_PROTO)

GENERATE_PROTO("${THIRD_PARTY_COMMON_DIR}/trezorCommon" "${BLOCKSETTLE_HW_ROOT}/trezor/generated_proto")

ADD_LIBRARY(${BLOCKSETTLE_HW_LIBRARY_NAME} ${GENERATED_SOURCE_FILES} ${GENERATED_HEADER_FILES} ${SOURCES} ${HEADERS})

TARGET_LINK_LIBRARIES(${BLOCKSETTLE_HW_LIBRARY_NAME}
   ${LIBUSB_LIB}
   ${BS_NETWORK_LIB_NAME}
   ${CPP_WALLET_LIB_NAME}
   ${COMMON_LIB_NAME}
   ${PROTO_LIB}
   Qt5::Core
   Qt5::Network
)

=== BlockSettleSigner/CMakeLists.txt ===
#
#
# ***********************************************************************************
# * Copyright (C) 2018 - 2020, BlockSettle AB
# * Distributed under the GNU Affero General Public License (AGPL v3)
# * See LICENSE or http://www.gnu.org/licenses/agpl.html
# *
# **********************************************************************************
#
#
PROJECT( ${SIGNER_APP_NAME} )

configure_file(SignerVersion.h.in SignerVersion.h)

SET(BSNetwork ${BLOCK_SETTLE_ROOT}/common/BlocksettleNetworkingLib)

FILE(GLOB SOURCES *.cpp)
FILE(GLOB SOURCES_QML interfaces/GUI_QML/*.cpp)
LIST(APPEND SOURCES ${SOURCES_QML})

FILE(GLOB HEADERS *.h)
FILE(GLOB HEADERS_QML interfaces/GUI_QML/*.h)
LIST(APPEND HEADERS ${HEADERS_QML})

FILE(GLOB RESOURCE_FILES *.qrc)

FILE(GLOB BIP39DICTIONARIES ${THIRD_PARTY_COMMON_DIR}/bips/bip-0039/*.txt)
FILE(COPY ${BIP39DICTIONARIES}
    DESTINATION ${CMAKE_CURRENT_SOURCE_DIR}/bip39Dictionaries)

INCLUDE_DIRECTORIES( interfaces/GUI_QML )
INCLUDE_DIRECTORIES( ${COMMON_LIB_INCLUDE_DIR} )
INCLUDE_DIRECTORIES( ${BS_NETWORK_INCLUDE_DIR} )
INCLUDE_DIRECTORIES( ${BS_COMMON_ENUMS_INCLUDE_DIR} )
INCLUDE_DIRECTORIES( ${BS_COMMUNICATION_INCLUDE_DIR} )
INCLUDE_DIRECTORIES( ${BS_STORAGE_INCLUDE_DIR} )
INCLUDE_DIRECTORIES( ${WALLET_LIB_INCLUDE_DIR} )
INCLUDE_DIRECTORIES( ${CRYPTO_LIB_INCLUDE_DIR} )
INCLUDE_DIRECTORIES( ${PATH_TO_GENERATED} )
INCLUDE_DIRECTORIES( ${NETTY_INCLUDE_DIR} )
INCLUDE_DIRECTORIES( ${BS_TERMINAL_API_INCLUDE_DIR} )
INCLUDE_DIRECTORIES( ${MARKET_ENUMS_INCLUDE_DIR} )
INCLUDE_DIRECTORIES( ${BOTAN_INCLUDE_DIR} )
INCLUDE_DIRECTORIES( ${COMMON_UI_LIB_INCLUDE_DIR} )
INCLUDE_DIRECTORIES( ${BLOCKSETTLE_UI_INCLUDE_DIR} )
INCLUDE_DIRECTORIES( ${Qt5DBus_INCLUDE_DIRS} )
INCLUDE_DIRECTORIES( ${BS_HW_LIB_INCLUDE_DIR} )

qt5_add_resources( GENERATED_RESOURCES ${RESOURCE_FILES})
qt5_add_resources( GENERATED_RESOURCES ${BLOCKSETTLE_UI_INCLUDE_DIR}/armory.qrc)

IF ( APPLE )
    SET( BUNDLE_NAME "BlockSettle Signer" )

    SET( MACOSX_BUNDLE_BUNDLE_NAME ${BUNDLE_NAME} )
    SET( MACOSX_BUNDLE_GUI_IDENTIFIER "com.blocksettle.signer" )
    SET( MACOSX_BUNDLE_BUNDLE_VERSION ${BS_VERSION_STRING})
    SET( MACOSX_BUNDLE_SHORT_VERSION_STRING ${BS_VERSION_STRING})
    SET( MACOSX_BUNDLE_LONG_VERSION_STRING ${BS_VERSION_STRING})

    SET( MACOSX_BUNDLE_ICON_FILE "interfaces/GUI_QML/blocksettle_signer.icns" )

    SET(BS_SIGNER_ICNS_FILE "interfaces/GUI_QML/blocksettle_signer.icns")

    SET_SOURCE_FILES_PROPERTIES(${BS_SIGNER_ICNS_FILE} PROPERTIES MACOSX_PACKAGE_LOCATION Resources)
    ADD_EXECUTABLE(${SIGNER_APP_NAME} MACOSX_BUNDLE ${SOURCES} ${HEADERS} ${GENERATED_RESOURCES} ${BS_SIGNER_ICNS_FILE})
    SET_TARGET_PROPERTIES(${SIGNER_APP_NAME} PROPERTIES OUTPUT_NAME "${BUNDLE_NAME}")
ELSEIF ( WIN32 )
#   SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} /SUBSYSTEM:WINDOWS /ENTRY:mainCRTStartup")
    ADD_EXECUTABLE(${SIGNER_APP_NAME} WIN32 ${SOURCES} ${HEADERS} ${GENERATED_RESOURCES} blocksettle.rc)
ELSE ()
    ADD_EXECUTABLE(${SIGNER_APP_NAME} ${SOURCES} ${HEADERS} ${GENERATED_RESOURCES})
ENDIF ()


TARGET_LINK_LIBRARIES(${SIGNER_APP_NAME}
   ${BLOCKSETTLE_UI_LIBRARY_NAME}
   ${BS_NETWORK_LIB_NAME}
   ${BLOCKSETTLE_HW_LIBRARY_NAME}
   ${CPP_WALLET_LIB_NAME}
   ${CRYPTO_LIB_NAME}
   ${BOTAN_LIB}
   ${ZMQ_LIB}
   ${WS_LIB}
   ${QRENCODE_LIB}
   ${QT_LINUX_LIBS}
   ${QT_QUICK_LIBS}
   Qt5::Qml
   Qt5::Quick
   Qt5::Gui
   Qt5::DBus
   Qt5::Network
   Qt5::PrintSupport
   Qt5::Core
   ${QT_LIBS}
   ${OS_SPECIFIC_LIBS}
   ${OPENSSL_LIBS}
)

=== BlockSettleTracker/CMakeLists.txt ===
#
#
# ***********************************************************************************
# * Copyright (C) 2020 - 2020, BlockSettle AB
# * Distributed under the GNU Affero General Public License (AGPL v3)
# * See LICENSE or http://www.gnu.org/licenses/agpl.html
# *
# **********************************************************************************
#
#
CMAKE_MINIMUM_REQUIRED(VERSION 3.3)

SET(BLOCKSETTLE_TRACKER blocksettle_tracker)
PROJECT(${BLOCKSETTLE_TRACKER})

configure_file(BsTrackerVersion.h.in BsTrackerVersion.h)

SET(TRACKER_SOURCES
   main.cpp
)

INCLUDE_DIRECTORIES(${WALLET_LIB_INCLUDE_DIR})
INCLUDE_DIRECTORIES(${BS_NETWORK_INCLUDE_DIR})
INCLUDE_DIRECTORIES(${BS_COMMUNICATION_INCLUDE_DIR})
INCLUDE_DIRECTORIES(${COMMON_LIB_INCLUDE_DIR})

ADD_EXECUTABLE(${BLOCKSETTLE_TRACKER}
   ${TRACKER_SOURCES}
)

TARGET_LINK_LIBRARIES(${BLOCKSETTLE_TRACKER}
   ${BS_NETWORK_LIB_NAME}
   ${ZMQ_LIB}
   ${CMAKE_THREAD_LIBS_INIT}
)

=== BlockSettleUILib/CMakeLists.txt ===
#
#
# ***********************************************************************************
# * Copyright (C) 2018 - 2020, BlockSettle AB
# * Distributed under the GNU Affero General Public License (AGPL v3)
# * See LICENSE or http://www.gnu.org/licenses/agpl.html
# *
# **********************************************************************************
#
#
CMAKE_MINIMUM_REQUIRED( VERSION 3.3 )

SET(CMAKE_CXX_STANDARD 14)
SET(CMAKE_CXX_STANDARD_REQUIRED ON)
SET(CMAKE_CXX_EXTENSIONS OFF)

PROJECT( ${BLOCKSETTLE_UI_LIBRARY_NAME} )

configure_file(TerminalVersion.h.in TerminalVersion.h)

FILE(GLOB SOURCES
   *.cpp
   CustomControls/*.cpp
   InfoDialogs/*.cpp
   ManageEncryption/*.cpp
   Settings/*.cpp
   Trading/*.cpp
   ChatUI/*.cpp
   ChatUI/ChatWidgetStates/*.cpp
   ChatUI/OTCShieldWidgets/*.cpp
)
FILE(GLOB HEADERS
   *.h
   CustomControls/*.h
   InfoDialogs/*.h
   ManageEncryption/*.h
   Settings/*.h
   Trading/*.h
   ChatUI/*.h
   ChatUI/ChatWidgetStates/*.h
   ChatUI/OTCShieldWidgets/*.h
)
FILE(GLOB UI_FILES
   *.ui
   CustomControls/*.ui
   InfoDialogs/*.ui
   ManageEncryption/*.ui
   Settings/*.ui
   Trading/*.ui
   ChatUI/*.ui
   ChatUI/OTCShieldWidgets/*.ui
)

FILE(GLOB RESOURCE_FILES *.qrc)

INCLUDE_DIRECTORIES( ${WALLET_LIB_INCLUDE_DIR} )
INCLUDE_DIRECTORIES( ${CRYPTO_LIB_INCLUDE_DIR} )
INCLUDE_DIRECTORIES( ${BS_NETWORK_INCLUDE_DIR} )
INCLUDE_DIRECTORIES( ${COMMON_LIB_INCLUDE_DIR} )
INCLUDE_DIRECTORIES( ${COMMON_UI_LIB_INCLUDE_DIR} )
INCLUDE_DIRECTORIES( Settings )
INCLUDE_DIRECTORIES( Trading )

foreach(RESOURCE_FILE ${RESOURCE_FILES})
	qt5_add_resources( GENERATED_RESOURCES ${RESOURCE_FILE})
endforeach()
qt5_wrap_ui( GENERATED_UI ${UI_FILES} )

INCLUDE_DIRECTORIES( ${Qt5Gui_INCLUDE_DIRS} )
INCLUDE_DIRECTORIES( ${Qt5Widgets_INCLUDE_DIRS} )
INCLUDE_DIRECTORIES( ${Qt5Core_INCLUDE_DIRS})
INCLUDE_DIRECTORIES( ${Qt5Network_INCLUDE_DIRS} )
INCLUDE_DIRECTORIES( ${Qt5Qml_INCLUDE_DIRS} )
INCLUDE_DIRECTORIES( ${Qt5DBus_INCLUDE_DIRS} )
INCLUDE_DIRECTORIES( ${Qt5Charts_INCLUDE_DIRS} )
INCLUDE_DIRECTORIES( ${Qt5Sql_INCLUDE_DIRS} )

INCLUDE_DIRECTORIES( ${BOTAN_INCLUDE_DIR} )

ADD_LIBRARY( ${BLOCKSETTLE_UI_LIBRARY_NAME}
   ${SOURCES}
   ${HEADERS}
   ${GENERATED_RESOURCES}
   ${GENERATED_UI}
)

TARGET_LINK_LIBRARIES(${BLOCKSETTLE_UI_LIBRARY_NAME}
   ${CRYPTO_LIB_NAME}
   ${BOTAN_LIB}
   ${OS_SPECIFIC_LIBS}
   ${COMMON_LIB_NAME}
   ${COMMON_UI_LIB_NAME}
   ${QRENCODE_LIB}
   ${AUTH_PROTO_LIB_NAME}
   ${BS_PROTO_LIB_NAME}
   ${CELER_PROTO_LIB_NAME}
   Qt5::Core
   Qt5::Widgets
   Qt5::Gui
   Qt5::Network
   Qt5::Qml
   Qt5::Charts
)

=== CommonUI/CMakeLists.txt ===
#
#
# ***********************************************************************************
# * Copyright (C) 2018 - 2020, BlockSettle AB
# * Distributed under the GNU Affero General Public License (AGPL v3)
# * See LICENSE or http://www.gnu.org/licenses/agpl.html
# *
# **********************************************************************************
#
#
CMAKE_MINIMUM_REQUIRED( VERSION 3.3 )

SET(CMAKE_CXX_STANDARD 14)
SET(CMAKE_CXX_STANDARD_REQUIRED ON)
SET(CMAKE_CXX_EXTENSIONS OFF)

PROJECT( ${COMMON_UI_LIB_NAME} )

FILE(GLOB SOURCES *.cpp)
FILE(GLOB HEADERS *.h)
FILE(GLOB UI_FILES *.ui )
FILE(GLOB RESOURCE_FILES *.qrc)

IF (APPLE)
   FILE(GLOB OBJS *.mm)
   SET(SOURCES ${SOURCES} ${OBJS})
ENDIF(APPLE)

INCLUDE_DIRECTORIES( ${COMMON_LIB_INCLUDE_DIR} )

qt5_add_resources( GENERATED_RESOURCES ${RESOURCE_FILES})
qt5_wrap_ui( GENERATED_UI ${UI_FILES} )

INCLUDE_DIRECTORIES( ${Qt5Gui_INCLUDE_DIRS} )
INCLUDE_DIRECTORIES( ${Qt5Widgets_INCLUDE_DIRS} )
INCLUDE_DIRECTORIES( ${Qt5Core_INCLUDE_DIRS})
INCLUDE_DIRECTORIES( ${Qt5Network_INCLUDE_DIRS} )
INCLUDE_DIRECTORIES( ${Qt5PrintSupport_INCLUDE_DIRS} )
INCLUDE_DIRECTORIES( ${Qt5DBus_INCLUDE_DIRS} )

ADD_LIBRARY( ${COMMON_UI_LIB_NAME}
   ${SOURCES}
   ${HEADERS}
   ${GENERATED_RESOURCES}
   ${GENERATED_UI})

TARGET_LINK_LIBRARIES(${COMMON_UI_LIB_NAME}
   ${OS_SPECIFIC_LIBS}
   ${COMMON_LIB_NAME}
   Qt5::Core
   Qt5::Widgets
   Qt5::Gui
   Qt5::Network
   Qt5::PrintSupport
   Qt5::DBus
   )

=== UnitTests/CMakeLists.txt ===
#
#
# ***********************************************************************************
# * Copyright (C) 2019 - 2020, BlockSettle AB
# * Distributed under the GNU Affero General Public License (AGPL v3)
# * See LICENSE or http://www.gnu.org/licenses/agpl.html
# *
# **********************************************************************************
#
#
CMAKE_MINIMUM_REQUIRED( VERSION 3.3 )

SET(UNIT_TESTS unit_tests)
PROJECT( ${UNIT_TESTS} )

FILE(GLOB SOURCES *.cpp)
FILE(GLOB HEADERS *.h)

# These files are not included even if terminalGUI is built with BUILD_TEST_TOOLS=1,
# including them once again for now as a workaround
LIST (APPEND SOURCES
   ${TERMINAL_GUI_ROOT}/common/ArmoryDB/cppForSwig/BDM_mainthread.cpp
   ${TERMINAL_GUI_ROOT}/common/ArmoryDB/cppForSwig/BDM_Server.cpp
   ${TERMINAL_GUI_ROOT}/common/ArmoryDB/cppForSwig/BitcoinP2P.cpp
   ${TERMINAL_GUI_ROOT}/common/ArmoryDB/cppForSwig/Blockchain.cpp
   ${TERMINAL_GUI_ROOT}/common/ArmoryDB/cppForSwig/BlockchainScanner.cpp
   ${TERMINAL_GUI_ROOT}/common/ArmoryDB/cppForSwig/BlockchainScanner_Super.cpp
   ${TERMINAL_GUI_ROOT}/common/ArmoryDB/cppForSwig/BlockDataMap.cpp
   ${TERMINAL_GUI_ROOT}/common/ArmoryDB/cppForSwig/BlockDataViewer.cpp
   ${TERMINAL_GUI_ROOT}/common/ArmoryDB/cppForSwig/BlockObj.cpp
   ${TERMINAL_GUI_ROOT}/common/ArmoryDB/cppForSwig/BlockUtils.cpp
   ${TERMINAL_GUI_ROOT}/common/ArmoryDB/cppForSwig/BtcWallet.cpp
   ${TERMINAL_GUI_ROOT}/common/ArmoryDB/cppForSwig/DatabaseBuilder.cpp
   ${TERMINAL_GUI_ROOT}/common/ArmoryDB/cppForSwig/HistoryPager.cpp
   ${TERMINAL_GUI_ROOT}/common/ArmoryDB/cppForSwig/LedgerEntry.cpp
   ${TERMINAL_GUI_ROOT}/common/ArmoryDB/cppForSwig/nodeRPC.cpp
   ${TERMINAL_GUI_ROOT}/common/ArmoryDB/cppForSwig/Progress.cpp
   ${TERMINAL_GUI_ROOT}/common/ArmoryDB/cppForSwig/ScrAddrFilter.cpp
   ${TERMINAL_GUI_ROOT}/common/ArmoryDB/cppForSwig/ScrAddrObj.cpp
   ${TERMINAL_GUI_ROOT}/common/ArmoryDB/cppForSwig/Server.cpp
   ${TERMINAL_GUI_ROOT}/common/ArmoryDB/cppForSwig/SshParser.cpp
   ${TERMINAL_GUI_ROOT}/common/ArmoryDB/cppForSwig/StoredBlockObj.cpp
   ${TERMINAL_GUI_ROOT}/common/ArmoryDB/cppForSwig/txio.cpp
   ${TERMINAL_GUI_ROOT}/common/ArmoryDB/cppForSwig/ZeroConf.cpp
   ${TERMINAL_GUI_ROOT}/common/ArmoryDB/cppForSwig/gtest/NodeUnitTest.cpp
   )

INCLUDE_DIRECTORIES( ${BLOCKSETTLE_UI_INCLUDE_DIR} )
INCLUDE_DIRECTORIES( ${BS_NETWORK_INCLUDE_DIR} )
INCLUDE_DIRECTORIES( ${COMMON_LIB_INCLUDE_DIR} )
INCLUDE_DIRECTORIES( ${CRYPTO_LIB_INCLUDE_DIR} )
INCLUDE_DIRECTORIES( ${WALLET_LIB_INCLUDE_DIR} )

INCLUDE_DIRECTORIES( ${BS_COMMUNICATION_INCLUDE_DIR} )
INCLUDE_DIRECTORIES( ${PATH_TO_GENERATED} )

INCLUDE_DIRECTORIES( ${NETTY_INCLUDE_DIR} )
INCLUDE_DIRECTORIES( ${BS_COMMON_ENUMS_INCLUDE_DIR} )
INCLUDE_DIRECTORIES( ${BS_TERMINAL_API_INCLUDE_DIR} )
INCLUDE_DIRECTORIES( ${MARKET_ENUMS_INCLUDE_DIR} )

ADD_EXECUTABLE( ${UNIT_TESTS}
   ${SOURCES}
   ${HEADERS}
)

TARGET_COMPILE_DEFINITIONS( ${UNIT_TESTS} PRIVATE
   SPDLOG_ACTIVE_LEVEL=SPDLOG_LEVEL_DEBUG
   COINBASE_MATURITY_TESTS
)

TARGET_LINK_LIBRARIES( ${UNIT_TESTS}
   ${BLOCKSETTLE_UI_LIBRARY_NAME}
   ${CPP_WALLET_LIB_NAME}
   ${BS_NETWORK_LIB_NAME}
   ${CRYPTO_LIB_NAME}
   ${LIBBTC_LIB}
   ${MPIR_LIB}
   ${BOTAN_LIB}
   ${COMMON_LIB}
   ${PROTO_LIB}
   ${ZMQ_LIB}
   ${GTEST_LIB}
   ${BS_PROTO_LIB_NAME}
   ${AUTH_PROTO_LIB}
   ${BS_PROTO_LIB}
   ${CELER_PROTO_LIB}

   ${QT_LINUX_LIBS}
   ${WS_LIB}
   Qt5::Qml
   Qt5::Core
   Qt5::Widgets
   Qt5::Gui
   Qt5::Network
   Qt5::PrintSupport
   Qt5::Core
   Qt5::Svg
   Qt5::DBus
   ${QT_LIBS}
   ${OS_SPECIFIC_LIBS}
   ${OPENSSL_LIBS}
)

TARGET_INCLUDE_DIRECTORIES( ${UNIT_TESTS}
   PRIVATE ${BOTAN_INCLUDE_DIR}
)

=== debian/changelog ===
bsterminal (0.20.3~git20191115.2.54d2354f-1) unstable; urgency=medium

  * New upstream release

 -- BlockSettle AB <hello@blocksettle.com>  Fri, 22 Nov 2019 10:04:13 +0530

bsterminal (0.20.0~git20191120.1.6a7014a6-1) unstable; urgency=medium

  * New upstream release

 -- BlockSettle AB <hello@blocksettle.com>  Fri, 22 Nov 2019 02:10:06 +0530

bsterminal (0.20.0~git20190816.3.70680682-1) unstable; urgency=medium

  * Initial release

 -- BlockSettle AB <hello@blocksettle.com>  Fri, 16 Aug 2019 09:32:04 +0000

=== debian/control ===
Source: bsterminal
Section: net
Priority: optional
Maintainer: BlockSettle AB <hello@blocksettle.com>
Build-Depends: debhelper (>= 9),
               cmake,
               pkg-config,
               python,
               python-requests,
               libmysqlclient-dev,
               autoconf,
               libtool,
               yasm,
               nasm,
               g++,
               default-libmysqlclient-dev,
               dh-exec,
               dpkg-dev (>= 1.17.14),
               firebird-dev [kfreebsd-any linux-any],
               freetds-dev,
               gdb,
               libasound2-dev [linux-any],
               libatspi2.0-dev,
               libcups2-dev,
               libdbus-1-dev,
               libdouble-conversion-dev,
               libfontconfig1-dev,
               libfreetype6-dev,
               libgbm-dev [linux-any kfreebsd-any],
               libgl1-mesa-dev | libgl-dev,
               libgles2-mesa-dev | libgles2-dev,
               libglib2.0-dev,
               libglu1-mesa-dev | libglu-dev,
               libgtk-3-dev,
               libharfbuzz-dev,
               libicu-dev,
               libinput-dev [linux-any],
               libjpeg-dev,
               libmtdev-dev [linux-any],
               libpng-dev,
               libpq-dev,
               libproxy-dev,
               libpulse-dev,
               libsqlite3-dev,
               libssl-dev,
               libudev-dev [linux-any],
               libx11-dev,
               libx11-xcb-dev,
               libxcb-icccm4-dev,
               libxcb-image0-dev,
               libxcb-keysyms1-dev,
               libxcb-randr0-dev,
               libxcb-render-util0-dev,
               libxcb-render0-dev,
               libxcb-shape0-dev,
               libxcb-shm0-dev,
               libxcb-sync-dev,
               libxcb-xfixes0-dev,
               libxcb-xinerama0-dev,
               libxcb-xkb-dev,
               libxcb1-dev,
               libxext-dev,
               libxi-dev,
               libxkbcommon-dev,
               libxkbcommon-x11-dev,
               libxrender-dev,
               pkg-kde-tools (>= 0.15.17~),
               publicsuffix,
               unixodbc-dev,
               zlib1g-dev
Standards-Version: 4.1.2
Homepage: http://blocksettle.com

Package: bsterminal
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, desktop-file-utils, xdg-utils
Description: BlockSettle bitcoin terminal and wallet manager
 This application is as terminal for BlockSettle's real-time
 settlement network, but can also act as a comprehensive Bitcoin
 wallet software.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE := 1
export DEB_BUILD_OPTIONS := parallel=$(shell nproc) $(DEB_BUILD_OPTIONS)

%:
	dh $@ --build-system=cmake --parallel --without autoreconf

override_dh_auto_configure:
	BS_GIT_REVISION="1702d72825958d125c935f6f48863469708447b2" DEV_3RD_ROOT=`pwd`/deps python ./generate.py release
	BS_GIT_REVISION="1702d72825958d125c935f6f48863469708447b2" DEV_3RD_ROOT=`pwd`/deps dh_auto_configure -- -DPRODUCTION_BUILD=1 -Wno-dev -DCMAKE_BUILD_TYPE=Release

override_dh_auto_install:
	dh_auto_install
	mkdir -p $(CURDIR)/debian/bsterminal/usr/bin/
	cp $(CURDIR)/build_terminal/Release/bin/blocksettle $(CURDIR)/debian/bsterminal/usr/bin/
	cp $(CURDIR)/build_terminal/Release/bin/blocksettle_signer $(CURDIR)/debian/bsterminal/usr/bin/
	cp $(CURDIR)/Deploy/Ubuntu/usr -r $(CURDIR)/debian/bsterminal/

override_dh_auto_clean:
	dh_auto_clean
	rm -rf "$(CURDIR)/generated_proto"
	rm -rf "$(CURDIR)/build_terminal"
	rm -rf "$(CURDIR)/external/build_"*
